/*********************************************
  
AVR Studio 4.19 + AVR Toolchain 3.3.1

	: Mcuzuaa
	: 5.4
    : 14.01.2013
   : 
:   Ni-Cd  Ni-MH     .


 : ATmega8L
     : 4,000000 MHz
FuseL				: 0x1F
CKSEL				: 1111
SUT				: 01
BODEN				: 0
BODLEVEL			: 0
FuseH				: 0xC9
BOOTRST				: 1
BOOTSZ				: 00
EESAVE				: 1
CKPOT				: 0
SPIEN				: 0
WDTON				: 1
RSTDISBL			: 1
*********************************************/

// 
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>

// 
typedef unsigned bit;
typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned long int dword;

//  2,56 
#define ADC_VREF_TYPE 0xC0
#define NUM_CONST 0x0100

// 
volatile struct
	{
	bit intrup:1; // 
	bit numakk:1; //  
	bit indic:1; // 
	}flag;

struct
	{
	byte index; //  1
	byte numprg; //   1
	byte capind; //    1
	byte ucon; //    1
	byte hitmpr; //   1
	byte error; //   1
	byte outzrz; //     1   1
	word maxvlt; //   1
	word captr; //  1
	word cloc1; //   1
	word cloc2; //   2
	word tmpair; //  1
	dword sumcap;  // -   1
	}akk1;

struct
	{
	byte index; //  2
	byte numprg; //   2
	byte capind; //    2
	byte ucon; //    2
	byte hitmpr; //   2
	byte error; //   2
	byte outzrz; //     2   2
	word maxvlt; //   2
	word captr; //  2
	word cloc1; //   3
	word cloc2; //   4
	word tmpair; //  2
	dword sumcap;  // -   2
	}akk2;

volatile byte cloc_intrup; // 
volatile byte cloc_ucnakk; //    

static EEMEM dword ref_ion=2661; //   2,56   
static EEMEM dword ostcap_akk1[2]={0,0}; //      1
static EEMEM dword ostcap_akk2[2]={0,0}; //      2
static EEMEM word harg_capakk1; //     1
static EEMEM word harg_capakk2; //     2
static EEMEM byte harg_index1; //      1
static EEMEM byte harg_index2; //      2
static EEMEM byte harg_numprg1; //      1
static EEMEM byte harg_numprg2; //      2
static EEMEM byte harg_tmp; //    eeprom
static EEMEM byte ofset_zro1h=0x01; //      1
static EEMEM byte ofset_zro1l=0x00; //      1
static EEMEM byte ofset_zro2h=0x01; //       2
static EEMEM byte ofset_zro2l=0x00; //      2

// 
byte scan_numprg(void); //  
byte detect_wire(byte input_prm,byte index_prm); //  - 
word read_adc(byte adc_input); //  
word measur_curakk(void); //  - 
word scan_captr(void); //   
word tempr_akk(void); //   1
void out_tik(word tim_prm); //  ,   
void out_dbltik(void); //     50 
void con_indnor(void); //  
void con_inderr(void); //  
void ucon_indner(void); //    
void con_indzar(void); //  
void con_indraz(void); //  
void ucon_indzrz(void); //    
void zrocur_akk(void); //  
void cur01_zrakk(void); //   100  
void regcur_akk1(word reg_prm); //   1
void regcur_akk2(word reg_prm); //   2
void inirst_akk(void); //  
void detect_akk(byte *flag_prm,byte *indakk_prm,word *cloc_prm); //  
void capnum_akk(byte *flag_prm,byte *numprg_prm,byte *index_prm,word *cloc_prm,word *captr_prm); //    
void razrd_akk(byte flag1_prm,byte *flag2_prm,byte *capind_prm,byte numprg_prm,byte *index_prm,word captr_prm,word *cloc_prm,dword *sumcap_prm); // 
void zard_akk(byte flag1_prm,byte *flag2_prm,byte *flag3_prm,byte *capind_prm,byte numprg_prm,byte *index_prm,word captr_prm,word *cloc1_prm,word *cloc2_prm,word *maxvlt_prm,dword *sumcap_prm); // 
void harg_prmakk(void); //    
void stopzrz_akk1(void); //     1
void stopzrz_akk2(void); //     2
void setadc_zrocur(void); // 
void podgot_setadc(void); //     

//    0
ISR(TIMER0_OVF_vect)
	{
	TCNT0=0x06; //  0
	cloc_intrup++; //  
	if(cloc_intrup==125) //   125
    	{
    	flag.intrup=1; //    0,5 
		flag.numakk=~flag.numakk; //   
		if(flag.numakk==1) //     
			{
			cloc_ucnakk++;
			if(cloc_ucnakk>3) cloc_ucnakk=0;
			}
    	cloc_intrup=0; //  
    	}
	}

// 
word read_adc(byte adc_input) 
	{
	dword adc_tmp=0; // 
	byte clc_tmp=0;
	ADMUX=adc_input|(ADC_VREF_TYPE&0xFF); //  
	_delay_us(10); //     
	do // 
		{
   		ADCSRA|=0x40; // 
   		while((ADCSRA & 0x10)==0); //  
   		ADCSRA|=0x10; //  
		adc_tmp+=(dword)ADCW; //  
		clc_tmp++; //   
		_delay_us(100); // 100 
		}
	while(clc_tmp!=5); //  5  
	adc_tmp=adc_tmp*eeprom_read_dword(&ref_ion)/(dword)5120; //  
	return (word)adc_tmp; //    
	}

//   
void out_tik(word tim_prm) 
	{
	word tim_tmp;
	tim_tmp=tim_prm*4; //  
	while(tim_tmp!=0) //    4 
    	{
    	_delay_us(125); //  
    	PORTD&=~_BV(PD4); //   .0
    	_delay_us(125); //   
    	PORTD|=_BV(PD4); //   .1
    	tim_tmp--; //   
    	}
	}

//    
void out_dbltik(void)
	{
	out_tik(50); //   50 
	_delay_ms(50); // 50 
	out_tik(50); //   50 
	}

//   
word scan_captr(void) 
	{
	word cap_tmp; // 
	PORTD&=~_BV(PD5); //  
	_delay_ms(1); // 1 
	cap_tmp=(word)(PIND&0x0F)*10; //  
	PORTD|=_BV(PD5); //  
	PORTD&=~_BV(PD6); //  
	_delay_ms(1);
	cap_tmp+=(word)(PIND&0x0F)*100; //      
	PORTD|=_BV(PD6); //  
	PORTD&=~_BV(PD7); //  
	_delay_ms(1);
	cap_tmp+=(word)(PIND&0x0F)*1000; //        
	PORTD|=_BV(PD7); //  
	return cap_tmp; //  
	}

//   
byte scan_numprg(void)
	{
	byte stp_tmp; // 
	PORTD&=~_BV(PD4); //   
	_delay_ms(1); // 1 
	stp_tmp=PIND&0x0F; //   
	PORTD|=_BV(PD4); //  
	return stp_tmp; //  
	}

//   
void con_indnor(void)
	{
	if(flag.numakk==0) //  1
		{
		PORTB|=_BV(PB0); //   .1
		DDRB|=_BV(DDB0); //   
		}
	else //  2
		{
		PORTB|=_BV(PB4); //   .1
		DDRB|=_BV(DDB4); //   
		}
	}

//   
void con_inderr(void)
	{
	if(flag.numakk==0) //  1
		{
		PORTB&=~_BV(PB0); //   .0
		DDRB|=_BV(DDB0); //   
		}
	else //  2
		{
		PORTB&=~_BV(PB4); //   .0
		DDRB|=_BV(DDB4); //   
		}
	}

//     
void ucon_indner(void)
	{
	if(flag.numakk==0) //  1
		{
		if(bit_is_set(PORTB,PB0)) PORTB&=~_BV(PB0); // .0   .1
		DDRB&=~_BV(DDB0); //   Z 
		}
	else //  2
		{
		if(bit_is_set(PORTB,PB4)) PORTB&=~_BV(PB4); // .0   .1
		DDRB&=~_BV(DDB4); //   Z 
		}
	}

//   
void con_indzar(void)
	{
	if(flag.numakk==0) //  1
		{
		PORTB|=_BV(PB3); //   .1
		DDRB|=_BV(DDB3); //   
		}
	else //  2
		{
		PORTB|=_BV(PB5); //   .1
		DDRB|=_BV(DDB5); //   
		}
	}

//   
void con_indraz(void)
	{
	if(flag.numakk==0) //  1
		{
		PORTB&=~_BV(PB3); //   .0
		DDRB|=_BV(DDB3); //   
		}
	else //  2
		{
		PORTB&=~_BV(PB5); //   .0
		DDRB|=_BV(DDB5); //   
		}
	}

//     
void ucon_indzrz(void)
	{
	if(flag.numakk==0) //  1
		{
		if(bit_is_set(PORTB,PB3)) PORTB&=~_BV(PB3); // .0   .1
		DDRB&=~_BV(DDB3); //   Z 
		}
	else //  2
		{
		if(bit_is_set(PORTB,PB5)) PORTB&=~_BV(PB5); // .0   .1
		DDRB&=~_BV(DDB5); //   Z 
		}
	}

//   
void zrocur_akk(void)
	{
	if(flag.numakk==0) //  1
		{
		OCR1AH=eeprom_read_byte(&ofset_zro1h); //       1
		OCR1AL=eeprom_read_byte(&ofset_zro1l); //       1
		}
	else //  2
		{
		OCR1BH=eeprom_read_byte(&ofset_zro2h); //       2
		OCR1BL=eeprom_read_byte(&ofset_zro2l); //       2
		}
	}

//  
void inirst_akk(void)
	{
	if(flag.numakk==0) //  1
		{
		akk1.cloc1=0; //    1
		akk1.cloc2=0; //    2
		akk1.numprg=0; //   
		akk1.sumcap=0; //  -
		akk1.captr=0; //   
		akk1.ucon=0; //    
		akk1.error=0; //  
		akk1.capind=0; //    
		out_tik(50); //  
		akk1.index=1; //   
		}
	else //  2
		{
		akk2.cloc1=0; //    3
		akk2.cloc2=0; //    4
		akk2.numprg=0; //   
		akk2.sumcap=0; //  -
		akk2.captr=0; //   
		akk2.ucon=0; //    
		akk2.error=0; //  
		akk2.capind=0; //    
		out_tik(50); //  
		akk2.index=1; //   
		}
	}

//   
void detect_akk(byte *flag_prm,byte *indakk_prm,word *cloc_prm)
	{
	byte inp_tmp;
	if(flag.numakk==0) inp_tmp=0; //        
	else inp_tmp=3;
	if(*cloc_prm>0) //     
    	{
    	if((measur_curakk()>50)||(read_adc(inp_tmp)<300)) //   50      
        	{
			if(*flag_prm==0) //     
				{
        		if(flag.indic==1) con_indnor(); //   
        		else ucon_indner();
				(*cloc_prm)++; //  
        		if(*cloc_prm>10) //    10
            		{
					zrocur_akk(); //  
            		*cloc_prm=0; //  1
					ucon_indner(); //  -
					ucon_indzrz(); //  -
					out_tik(50); // 
					*indakk_prm=2; //       
            		}
				}
			else //     
				{
				*flag_prm=0; //    
				ucon_indzrz(); //    
				ucon_indner(); //    
				}
        	}
		else if((scan_numprg()==9)&&(akk1.index==1)&&(akk2.index==1)) //   9
			{
			akk1.cloc1=0; //  1
			akk2.cloc1=0;
			akk1.index=7;  //     
			akk2.index=7;
			}
    	else //   50 
        	{
			if(*flag_prm==0) *flag_prm=1; //    
        	zrocur_akk(); //  
        	*cloc_prm=0; //  
        	}
    	}
	else
        {
        cur01_zrakk(); //    100 
        (*cloc_prm)++; //  
    	}
	if(*flag_prm==1) //        
		{
		switch(cloc_ucnakk)
			{
			case 0: ucon_indzrz();con_indnor();break; //  ,   
			case 1: ucon_indner();con_indzar();break; //  ,   
			case 2: ucon_indzrz();con_inderr();break; //  ,   
			case 3: ucon_indner();con_indraz();break; //  ,   
			}
		}
	}

//   
word measur_curakk(void) 
	{
	word adca_tmp; // 
	word adcb_tmp;
	if(flag.numakk==0)
    	{
    	adca_tmp=read_adc(0); //      1
    	adcb_tmp=read_adc(1);
    	}
	else
    	{
    	adca_tmp=read_adc(3); //      2
    	adcb_tmp=read_adc(4);
    	}
	if(adca_tmp<adcb_tmp) adca_tmp=(adcb_tmp-adca_tmp)*5; //  -  
	else adca_tmp=(adca_tmp-adcb_tmp)*5;
	return adca_tmp;
	}

//    100  
void cur01_zrakk(void)
	{
	word cap_tmp; // 
	if(flag.numakk==0)
		{
		cap_tmp=(word)eeprom_read_byte(&ofset_zro1h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro1l); //    
		cap_tmp+=10; //   100 
		regcur_akk1(cap_tmp); //  
		}
	else
		{
		cap_tmp=(word)eeprom_read_byte(&ofset_zro2h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro2l); //    
		cap_tmp+=10; //   100 
		regcur_akk2(cap_tmp); //  
		}
	}

//    1
void regcur_akk1(word reg_prm)
	{
	OCR1AH=(byte)(reg_prm/NUM_CONST); //    
	if(OCR1AH>0) OCR1AL=(byte)(reg_prm-NUM_CONST); //    
	else OCR1AL=(byte)reg_prm;
	}

//    2
void regcur_akk2(word reg_prm)
	{
	OCR1BH=(byte)(reg_prm/NUM_CONST); //    
	if(OCR1BH>0) OCR1BL=(byte)(reg_prm-NUM_CONST); //    
	else OCR1BL=(byte)reg_prm;
	}

//       
void capnum_akk(byte *flag_prm,byte *numprg_prm,byte *index_prm,word *cloc_prm,word *captr_prm)
	{
	byte reg_tmp; // 
	byte inp_tmp;
	word adc_tmp;
	if(flag.numakk==0) inp_tmp=0; //        
	else inp_tmp=3;
    if(flag.indic==1) con_indnor(); //   
    else ucon_indner();
    reg_tmp=scan_numprg(); //  
    if(reg_tmp<2) //    
        {
        if(flag.indic==1) con_indzar(); //     
        else con_indraz();
		if(*flag_prm==0) *flag_prm=1; //    
        out_tik(100); //  
        }
    else //   
        {
		if(*flag_prm==1) //     
			{
        	ucon_indzrz(); //    
			*flag_prm=0; //    
			}
		else //     
			{
        	if(*numprg_prm==reg_tmp) //     
            	{
				out_tik(25); //  
            	(*cloc_prm)++; //     
            	if(*cloc_prm>5) //     5
                	{
					out_dbltik(); //   
                	*cloc_prm=0; // 
					if(*numprg_prm==2) //   2
						{
						if((flag.numakk==0)&&(eeprom_read_dword(&ostcap_akk1[0])!=0)&&(eeprom_read_dword(&ostcap_akk1[0])==eeprom_read_dword(&ostcap_akk1[1])))
    						{ 
    						akk1.sumcap=eeprom_read_dword(&ostcap_akk1[0]); //    
    						akk1.index=eeprom_read_byte(&harg_index1); //   
							akk1.captr=eeprom_read_word(&harg_capakk1); //  
							akk1.numprg=eeprom_read_byte(&harg_numprg1); //   
    						}
						else if((flag.numakk==1)&&(eeprom_read_dword(&ostcap_akk2[0])!=0)&&(eeprom_read_dword(&ostcap_akk2[0])==eeprom_read_dword(&ostcap_akk2[1])))
    						{ 
    						akk2.sumcap=eeprom_read_dword(&ostcap_akk2[0]); //    
    						akk2.index=eeprom_read_byte(&harg_index2); //   
							akk2.captr=eeprom_read_word(&harg_capakk2); //  
							akk2.numprg=eeprom_read_byte(&harg_numprg2); //   
    						}
						}
					else if(*numprg_prm>2) //    3  9
						{
						*captr_prm=scan_captr(); //     
						adc_tmp=read_adc(inp_tmp); //  
						if((*numprg_prm==3)||(*numprg_prm==4)||(((*numprg_prm==5)||(*numprg_prm==6))&&(adc_tmp>1000))) *index_prm=3; //   3,4  5,6    1     
						else if(((*numprg_prm==5)||(*numprg_prm==6))&&(adc_tmp<=1000)) *index_prm=4; //   5  6    1   
						else if((*numprg_prm==7)||(*numprg_prm==8)||(*numprg_prm==9)) *index_prm=0;
						}
                	ucon_indner(); //  
					}
            	}
        	else //       
            	{
            	*numprg_prm=reg_tmp; //    
            	*cloc_prm=0; //    
            	}
			}
        }
    }

//   - 
byte detect_wire(byte input_prm,byte index_prm)
	{
	byte reg_tmp;
	if((read_adc(input_prm)<200)||((read_adc(input_prm)>2200)&&(measur_curakk()<50))) //         
    	{
		if(index_prm!=5)
			{
        	if(flag.indic==1) con_inderr(); //   
        	else ucon_indner(); 
        	out_tik(100); //  
			}
		reg_tmp=0; // 0   
		}
	else reg_tmp=1; // 1   
	return reg_tmp;
	}    

//  
void razrd_akk(byte flag1_prm,byte *flag2_prm,byte *capind_prm,byte numprg_prm,byte *index_prm,word captr_prm,word *cloc_prm,dword *sumcap_prm)
	{
	word cap_tmp=0; // 
	word tmpr_tmp;
	word adc_tmp;
	word cur_tmp;
	word reg_tmp=0;
	byte num_tmp;
	byte inp_tmp;
	byte ind_tmp;
	if(flag.numakk==0) inp_tmp=0; //        
	else inp_tmp=3;
	ind_tmp=*index_prm; //  
	if(detect_wire(inp_tmp,ind_tmp)==1) //  
    	{
		if(flag.indic==1)
			{
			con_indnor(); //  
			con_indraz(); //  
			}
		else
			{
			if(flag1_prm==1) ucon_indner(); //       
    		if((*capind_prm!=0)&&((numprg_prm==3)||(numprg_prm==4)))  //       
				{
				ucon_indzrz(); //  
				(*capind_prm)--; //  
				}
			}
    	tmpr_tmp=tempr_akk(); //  
    	adc_tmp=read_adc(inp_tmp); //  
    	cur_tmp=measur_curakk(); //   
    	if(((numprg_prm==4)||(numprg_prm==6))&&(flag1_prm==0)) //   4  6    
        	{
        	if((captr_prm*15/10)<1500) cap_tmp=captr_prm*15/10;  // 1,5<1500     1,5C
        	else cap_tmp=1500; // 1,5>=1500     1500 
        	}
    	else if((numprg_prm==3)||(numprg_prm==5)||(flag1_prm==1)) //   3  5    
        	{
        	if((captr_prm*8/10)<1000) cap_tmp=captr_prm*8/10;  // 0,8<1000      0,8C
        	else cap_tmp=1000; // 0,8>=1000 /    1000 
        	}
		*sumcap_prm=*sumcap_prm+cur_tmp; //  
		if(*capind_prm==0) //    
			{
			(*cloc_prm)++; //     
			if(*cloc_prm>10) //    10
				{
				*capind_prm=(byte)(*sumcap_prm/(dword)((dword)captr_prm*(dword)720)); //  
				*cloc_prm=0; //   
				}
			}
    	if((adc_tmp>1050)&&(cur_tmp<cap_tmp)) //    1,05      
        	{
			if(flag.numakk==0)
				{
        		reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //     1
        		reg_tmp--;
				regcur_akk1(reg_tmp); //  
        		}
			else
				{
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //     2
        		reg_tmp--;
				regcur_akk2(reg_tmp); //  
        		}
			}
    	else if((adc_tmp>1000)&&(cur_tmp>cap_tmp)) //    1      
        	{
			if(flag.numakk==0)
				{
        		reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //     1
        		reg_tmp++;
				regcur_akk1(reg_tmp); //  
        		}
			else
				{
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //     2
        		reg_tmp++;
				regcur_akk2(reg_tmp); //  
        		}
			}
    	else if((adc_tmp<=1000)&&(adc_tmp>200)) //    1 
        	{
        	if(((numprg_prm>4)&&(cur_tmp<(captr_prm/50)))||((numprg_prm<5)&&(cur_tmp<(captr_prm/100)))||(cur_tmp<10)) //    1/100      10 
            	{
				zrocur_akk(); //  
                ucon_indner(); //   1
                ucon_indzrz(); //   1
                *cloc_prm=0; //   
				*capind_prm=0; //  
				if(numprg_prm>4)
					{
					*sumcap_prm=0; //   
					*index_prm=4; //    4     
					}
                else
					{
					*flag2_prm=1; //     
					*index_prm=5; //    
					}
                }
        	else
            	{
				if(flag.numakk==0)
					{
            		reg_tmp=(((word)eeprom_read_byte(&ofset_zro1h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro1l))-((word)OCR1AH*NUM_CONST+(word)OCR1AL))/2+((word)OCR1AH*NUM_CONST+(word)OCR1AL); //      
            		regcur_akk1(reg_tmp); //  
					}
				else
					{
            		reg_tmp=(((word)eeprom_read_byte(&ofset_zro2h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro2l))-((word)OCR1BH*NUM_CONST+(word)OCR1BL))/2+((word)OCR1BH*NUM_CONST+(word)OCR1BL); //        
            		regcur_akk2(reg_tmp); //  
					}
				}
        	}
    	}
	else 
		{
		num_tmp=scan_numprg(); //  
		if(num_tmp<2) //    
			{
			zrocur_akk(); //  
			if(num_tmp==1) harg_prmakk(); //   1    
			out_dbltik(); //   
			*index_prm=0; //  
			}
		else
			{
			zrocur_akk(); //  
			if(flag.numakk==0)
				{
				reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //     1
        		reg_tmp-=10;
				regcur_akk1(reg_tmp); //  
        		}
			else
				{
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //     2
        		reg_tmp-=10;
				regcur_akk2(reg_tmp); //  
        		}
			}
		}
	}

//  
void zard_akk(byte flag1_prm,byte *flag2_prm,byte *flag3_prm,byte *capind_prm,byte numprg_prm,byte *index_prm,word captr_prm,word *cloc1_prm,word *cloc2_prm,word *maxvlt_prm,dword *sumcap_prm)
	{
	word cap_tmp=0; // 
	word tmpr_tmp;
	word adc_tmp;
	word cur_tmp;
	word reg_tmp=0;
	byte num_tmp;
	byte inp_tmp;
	byte ind_tmp;
	if(flag.numakk==0) inp_tmp=0; //        
	else inp_tmp=3;
	ind_tmp=*index_prm; //  
	if(detect_wire(inp_tmp,ind_tmp)==1) //  
    	{
    	if(flag.indic==1)
			{
			con_indnor(); //  
			con_indzar(); //  
			}
		else
			{
			if(flag1_prm==1) ucon_indner(); //       
    		if(*capind_prm!=0)  //       
				{
				ucon_indzrz(); //  
				(*capind_prm)--; //  
				}
			}
    	tmpr_tmp=tempr_akk(); //  
    	adc_tmp=read_adc(inp_tmp); //  
		cur_tmp=measur_curakk(); //   
		*sumcap_prm=*sumcap_prm+cur_tmp; //  
		if((numprg_prm==6)&&(flag1_prm==0)) //   6    
    		{
			if((captr_prm*15/10)<1500) cap_tmp=captr_prm*15/10; // 1,5<1500     1,5C
        	else cap_tmp=1500; // 1,5>1500      1500 
			}
    	else if((numprg_prm==5)||(flag1_prm==1)) //   5    
        	{
        	if((captr_prm*8/10)<1000) cap_tmp=captr_prm*8/10;  // 0,8<1000      0,8C
        	else cap_tmp=1000; // 0,8>1000 /    1000 
        	}
		if(*capind_prm==0) //    
			{
			(*cloc2_prm)++; //     
			if(*cloc2_prm>10) //    10
				{
				*capind_prm=(byte)(*sumcap_prm/(dword)((dword)captr_prm*(dword)720)); //  
				*cloc2_prm=0; //   
				}
			}
		if((*sumcap_prm/captr_prm)>2500) //     70%
        	{
			if(cur_tmp>(cap_tmp-cap_tmp/10)) //    
				{
        		if(adc_tmp>=*maxvlt_prm) //     
					{
					(*cloc1_prm)--; // 
					if(*cloc1_prm<15) //    
						{
						*maxvlt_prm=adc_tmp;  //  
						*cloc1_prm=20; //  
						}
					}
            	else if(*cloc1_prm<20) *cloc1_prm=20; //      
				else if(adc_tmp<*maxvlt_prm) //    
					{
            		if((((*maxvlt_prm-adc_tmp)>5)&&(numprg_prm==5))||(((*maxvlt_prm-adc_tmp)>10)&&(numprg_prm==6))) (*cloc1_prm)++; //       5   10 
					else *cloc1_prm=20; //       
                	}
            	}
        	}
    	else
			{
			*maxvlt_prm=adc_tmp; //    
			if(*cloc1_prm!=20) *cloc1_prm=20; //    
			}
    	if(cur_tmp<cap_tmp) //     
        	{
			if(flag.numakk==0)
				{
        		reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //   
        		reg_tmp++; //    10   1
        		regcur_akk1(reg_tmp); //  
				}
			else
				{
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //   
        		reg_tmp++; //    10   2
        		regcur_akk2(reg_tmp); //  
				}
			}
    	else if(cur_tmp>cap_tmp) //     
        	{
			if(flag.numakk==0)
				{
        		reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //   
        		reg_tmp--; //    10   1
        		regcur_akk1(reg_tmp); //  
				}
			else
				{
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //   
        		reg_tmp--; //    10   2
        		regcur_akk2(reg_tmp); //  
				}
			}
    	if(((flag1_prm==0)&&(tmpr_tmp>10)&&(*cloc1_prm>40)&&((*sumcap_prm/captr_prm)>3300))||(((*sumcap_prm/captr_prm)>3600)&&(flag1_prm==1))||(((*sumcap_prm/captr_prm)>4320)&&(tmpr_tmp>15))) //           100%
        	{ 
        	if(flag1_prm==1) *flag3_prm=1; //       
            zrocur_akk(); //  
            *cloc1_prm=0; //  
			*cloc2_prm=0;
			*flag2_prm=0; //     
            *index_prm=5; //     1
        	}
    	}
	else 
		{
		num_tmp=scan_numprg(); //  
		if(num_tmp<2) //    
			{
			zrocur_akk(); //  
			if(num_tmp==1) harg_prmakk(); //   1    
			out_dbltik(); //   
			*index_prm=0; //  
			}
		else
			{
			zrocur_akk(); //  
			if(flag.numakk==0)
				{
				reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //     1
        		reg_tmp+=10;
				regcur_akk1(reg_tmp); //  
        		}
			else
				{
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //     2
        		reg_tmp+=10;
				regcur_akk2(reg_tmp); //  
        		}
			}
		}
	}

//   -  1
void stopzrz_akk1(void)
	{
	word reg_tmp; // 
	if(flag.indic==1)
		{
		con_indnor(); //   1
		if(akk1.outzrz==0) //     
			{
			con_indzar(); //   1 
			if(((word)OCR1AH*NUM_CONST+(word)OCR1AL)==((word)eeprom_read_byte(&ofset_zro1h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro1l))) //  
				{
				reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //    
        		reg_tmp+=2; //c     20 
        		regcur_akk1(reg_tmp); //  
				}
			}
		else //     
			{
			con_indraz(); //   1 
			if(((word)OCR1AH*NUM_CONST+(word)OCR1AL)==((word)eeprom_read_byte(&ofset_zro1h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro1l))) //  
				{
				reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //    
        		reg_tmp-=2; //c     20 
        		regcur_akk1(reg_tmp); //  
				}
			}
		}
	else 
		{
		ucon_indzrz(); //   1   1
		if(akk1.error==1) ucon_indner(); //   1    
		}
	if(detect_wire(0,akk1.index)==1) //   
    	{
    	if(akk1.capind!=0)  //         
			{
			out_tik(25); //   25 
			akk1.capind--; //  
			}
		else
			{
    		akk1.cloc1++; // 
    		if(akk1.cloc1>10) //    10
        		{
				akk1.capind=(byte)(akk1.sumcap/(dword)((dword)akk1.captr*(dword)720)); //    
				if(akk1.capind==0) out_tik(100); //       
        		akk1.cloc1=0; // 
        		}
			}
    	}
	else //  
    	{
		zrocur_akk(); // 
		ucon_indner(); //   1
		ucon_indzrz(); //  - 1
    	out_dbltik(); //   
    	akk1.index=0; // 
    	}
	} 

//   -  2
void stopzrz_akk2(void)
	{
	word reg_tmp; // 
	if(flag.indic==1)
		{
		con_indnor(); //   2
		if(akk2.outzrz==0) //     
			{
			con_indzar(); //   1 
			if(((word)OCR1BH*NUM_CONST+(word)OCR1BL)==((word)eeprom_read_byte(&ofset_zro2h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro2l))) //  
				{
				reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //    
        		reg_tmp+=2; //c     20 
        		regcur_akk2(reg_tmp); //  
				}
			}
		else //     
			{
			con_indraz(); //   2
			if(((word)OCR1BH*NUM_CONST+(word)OCR1BL)==((word)eeprom_read_byte(&ofset_zro2h)*NUM_CONST+(word)eeprom_read_byte(&ofset_zro2l))) //  
				{
				reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //    
        		reg_tmp-=2; //c     20 
        		regcur_akk2(reg_tmp); //  
				}
			}
		}
	else 
		{
		ucon_indzrz(); //   2   2
		if(akk2.error==1) ucon_indner(); //   2    
		}
	if(detect_wire(3,akk2.index)==1) //   
    	{
    	if(akk2.capind!=0)  //         
			{
			out_tik(25); //   25 
			akk2.capind--; //  
			}
		else
			{
    		akk2.cloc1++; // 
    		if(akk2.cloc1>10) //    10
        		{
				akk2.capind=(byte)(akk2.sumcap/(dword)((dword)akk2.captr*(dword)720)); //    
				if(akk2.capind==0) out_tik(100); //       
        		akk2.cloc1=0; // 
        		}
			}
    	}
	else //  
    	{
		zrocur_akk(); // 
		ucon_indner(); //   2
		ucon_indzrz(); //  - 2
    	out_dbltik(); //   
    	akk2.index=0; // 
    	}
	} 

//    
void harg_prmakk(void)
	{
	if(flag.numakk==0)
		{
    	eeprom_update_dword(&ostcap_akk1[0],akk1.sumcap); //  
    	eeprom_update_dword(&ostcap_akk1[1],akk1.sumcap);
		eeprom_update_word(&harg_capakk1,akk1.captr); //  
		eeprom_update_byte(&harg_index1,akk1.index); //  
		eeprom_update_byte(&harg_numprg1,akk1.numprg); //  
    	eeprom_update_byte(&harg_tmp,akk1.numprg); //  eeprom
		}
	else
		{
    	eeprom_update_dword(&ostcap_akk2[0],akk2.sumcap); //  
    	eeprom_update_dword(&ostcap_akk2[1],akk2.sumcap);
		eeprom_update_word(&harg_capakk2,akk2.captr); //  
		eeprom_update_byte(&harg_index2,akk2.index); //  
		eeprom_update_byte(&harg_numprg2,akk2.numprg); //  
    	eeprom_update_byte(&harg_tmp,akk2.numprg); //  eeprom
		}
	}

//   
word tempr_akk(void) 
	{
	word adc_tmp; // 
	if(flag.numakk==0)
		{
		adc_tmp=read_adc(2); //    
		if (adc_tmp>=akk1.tmpair) adc_tmp=0;
		else adc_tmp=(akk1.tmpair-adc_tmp); //   
		if(adc_tmp>45) akk1.hitmpr=1; // ,   
		else akk1.hitmpr=0; //  
		}
	else
		{
		adc_tmp=read_adc(5); //    
		if (adc_tmp>=akk2.tmpair) adc_tmp=0;
		else adc_tmp=(akk2.tmpair-adc_tmp); //   
		if(adc_tmp>45) akk2.hitmpr=1; // ,   
		else akk2.hitmpr=0; //  
		}
	return adc_tmp; //  
	}

void podgot_setadc(void) //      
	{
	byte num_tmp; // 
	num_tmp=scan_numprg(); //  
    if(flag.indic==1) con_indnor(); //   
    else ucon_indner();
	if(num_tmp==9) //    
		{
		if(akk1.cloc1<2) //    2
			{
			zrocur_akk(); //  
			ucon_indzrz(); //    
			}
		akk1.cloc1++; //  
		out_tik(25); //  
		if(akk1.cloc1>10) //    10
			{
			akk1.cloc1=0; // 
			ucon_indner(); //  
			akk1.index=6; //   
			akk2.index=6;
			}
		}
	else //   
		{
		ucon_indner(); //  
		akk1.index=0; //  
		akk2.index=0;
		}
	}


//         -
void setadc_zrocur(void)
	{
	word cap_tmp; // 
	word adc_tmp;
	word reg_tmp;
	cap_tmp=scan_captr(); //   
	if((cap_tmp==0)&&(akk1.error==0)) akk1.error=1; //        
	cap_tmp=cap_tmp+scan_numprg(); // c   
	if(akk1.error==0) //    
		{
		if(flag.indic==1) con_inderr(); //  
		else ucon_indner(); //  
		if(akk1.captr==cap_tmp) //    
			{
			if((cap_tmp<2432)||(cap_tmp>2688)) //     5%   
        		{
				if(akk2.error==0) akk2.error=1; //  
        		if(flag.indic==1) con_indzar(); //     
        		else con_indraz();
        		out_tik(100); //  
        		}
			else if((cap_tmp>2431)&&(cap_tmp<2689)&&(akk2.error==1)) //        5%
				{
				ucon_indzrz(); //    
				akk2.cloc1++; //  
				if(akk2.cloc1>1) akk2.error=0;
				}
			else
				{
				out_tik(25); //      
				akk1.cloc1++; //  
				if(akk1.cloc1>10) //    10
					{
					eeprom_update_dword(&ref_ion,(dword)cap_tmp); //   
					akk1.cloc1=0; // 
					akk2.cloc1=0;
					akk1.error=1; //   
					out_dbltik(); //       
					}
				}
			}
		else //   
			{
			akk1.captr=cap_tmp; //   
			akk1.cloc1=0; //  
			}
		}
	else //    
		{
		if(flag.indic==1) con_indnor(); //  
		else if((flag.indic==0)&&(akk2.error==0)) ucon_indner(); //  
		if(flag.numakk==0)
			{
			adc_tmp=read_adc(0); //     1
			if((adc_tmp>2500)&&(akk1.capind==0)) //   2,5    1
				{
				if(akk1.cloc1>0) akk1.cloc1=0; //     
        		reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //       1
        		reg_tmp--; //   
				regcur_akk1(reg_tmp); //   
        		}
			else if((adc_tmp<2500)&&(akk1.capind==0)) //   2,5    1
				{
				akk1.cloc1++; // 
				if(akk1.cloc1>10) //   10 
					{
					akk1.cloc1=0; //  
					akk1.capind++; //  
					}
				}
			else if((adc_tmp<2500)&&(akk1.capind==1)) //   2,5    2
				{
				if(akk1.cloc1>0) akk1.cloc1=0; //     
        		reg_tmp=(word)OCR1AH*NUM_CONST+(word)OCR1AL; //       1
        		reg_tmp++; //   
				regcur_akk1(reg_tmp); //   
				}
			else if((adc_tmp>2500)&&(akk1.capind==1)) //   2,5    2
				{
				akk1.cloc1++; // 
				if(akk1.cloc1>10) //   10 
					{
					eeprom_update_byte(&ofset_zro1h,OCR1AH); //       1
					eeprom_update_byte(&ofset_zro1l,OCR1AL);
					akk1.cloc1=0; //  
					akk1.capind++; //  
					}
				}
			}
		else
			{
			adc_tmp=read_adc(3); //     2
			if((adc_tmp>2500)&&(akk2.capind==0)) //   2,5    1
				{
				if(akk2.cloc1>0) akk2.cloc1=0; //     
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //       2
        		reg_tmp--; //   
				regcur_akk2(reg_tmp); //   
        		}
			else if((adc_tmp<2500)&&(akk2.capind==0)) //   2,5    1
				{
				akk2.cloc1++; // 
				if(akk2.cloc1>10) //   10 
					{
					akk2.cloc1=0; //  
					akk2.capind++; //  
					}
				}
			else if((adc_tmp<2500)&&(akk2.capind==1)) //   2,5    2
				{
				if(akk2.cloc1>0) akk2.cloc1=0; //     
        		reg_tmp=(word)OCR1BH*NUM_CONST+(word)OCR1BL; //       2
        		reg_tmp++; //   
				regcur_akk2(reg_tmp); //   
				}
			else if((adc_tmp>2500)&&(akk2.capind==1)) //   2,5    2
				{
				akk2.cloc1++; // 
				if(akk2.cloc1>10) //   10 
					{
					eeprom_update_byte(&ofset_zro2h,OCR1BH); //       2
					eeprom_update_byte(&ofset_zro2l,OCR1BL);
					akk2.cloc1=0; //  
					akk2.capind++; //  
					}
				}

        	}
		}
	if((akk1.capind==2)&&(akk2.capind==2)&&(akk2.error==0)) akk2.error=1; //   
	if(cap_tmp==0) //    
		{
		akk1.cloc2++; // 
		if(akk1.cloc2>10) //   10 
			{
			akk1.index=0; //  
			akk2.index=0;
			}
		}
	else if(akk1.cloc2>0) akk1.cloc2=0; //  
	if(akk2.error==1) out_tik(10); //       
	}

int main(void)
	{
	// 
	byte clc_tmp; // 
	
	//  B
	PORTB=0x00;
	DDRB=0x06;

	//  C
	PORTC=0x00; //  Z-
	DDRC=0x00;

	//  D
	PORTD=0xFF; //PD0-PD3   , PD4-PD7   .1
	DDRD=0xF0;

	//  0
	TCCR0=0x03; //   62,500 
	TCNT0=0x06; //    6

	//  1
	TCCR1A=0xA2; //  Fast PWM  9- 
	TCCR1B=0x09; //  4000 
	TCNT1H=0x00; //  
	TCNT1L=0x00;
	ICR1H=0x00; //  
	ICR1L=0x00;

	//  2
	ASSR=0x00; //  
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00; 
	MCUCR=0x00; //  
	ACSR=0x80; // 
	SFIOR=0x00; // 
	ADMUX=ADC_VREF_TYPE&0xff; //   2,56 
	ADCSRA=0x85; //    125 

	clc_tmp=0; // 
	flag.numakk=1;
	zrocur_akk(); //   2
	con_inderr(); //   2
	flag.numakk=0;
	zrocur_akk(); //   1
	con_inderr(); //   1
	while(clc_tmp<60) //  1       
		{
		_delay_ms(1000); // 1 
		clc_tmp++; //  
		}
	clc_tmp=0; // 
	do //    
		{
		akk1.tmpair=read_adc(2); //  1
		akk2.tmpair=read_adc(5); //  2
		_delay_ms(1000); // 1 
		if((akk1.tmpair==read_adc(2))&&(akk2.tmpair==read_adc(5))) clc_tmp=1; //     
		}
	while (clc_tmp==0); //     
	flag.numakk=1; 
	ucon_indner(); //   2
	flag.numakk=0;
	ucon_indner(); //   1
	TIMSK=0x01; //     0
	sei(); //   

	while (1)
		{
		if(flag.intrup==1) //   
        	{
        	flag.intrup=0; //  
        	if(flag.numakk==0) //    0    1
            	{
            	flag.indic=~flag.indic; //  
            	switch(akk1.index) //  
                	{
                	case 0: inirst_akk();break; //  1
                	case 1: detect_akk(&akk1.ucon,&akk1.index,&akk1.cloc1);break; //   1
                	case 2: capnum_akk(&akk1.ucon,&akk1.numprg,&akk1.index,&akk1.cloc1,&akk1.captr);break; //      1
                	case 3: razrd_akk(akk1.hitmpr,&akk1.outzrz,&akk1.capind,akk1.numprg,&akk1.index,akk1.captr,&akk1.cloc1,&akk1.sumcap);break; //  1
                	case 4: zard_akk(akk1.hitmpr,&akk1.outzrz,&akk1.error,&akk1.capind,akk1.numprg,&akk1.index,akk1.captr,&akk1.cloc1,&akk1.cloc2,&akk1.maxvlt,&akk1.sumcap);break; //  1
                	case 5: stopzrz_akk1();break; // -  1
                	case 6: setadc_zrocur();break; //       -
					case 7: podgot_setadc();break; //        
                	}
            	}
        	else //    1    2
            	{
            	switch(akk2.index)
                	{
                	case 0: inirst_akk();break; //  2
                	case 1: detect_akk(&akk2.ucon,&akk2.index,&akk2.cloc1);break; //   2
                	case 2: capnum_akk(&akk2.ucon,&akk2.numprg,&akk2.index,&akk2.cloc1,&akk2.captr);break; //      2
                	case 3: razrd_akk(akk2.hitmpr,&akk2.outzrz,&akk2.capind,akk2.numprg,&akk2.index,akk2.captr,&akk2.cloc1,&akk2.sumcap);break; //  2
                	case 4: zard_akk(akk2.hitmpr,&akk2.outzrz,&akk2.error,&akk2.capind,akk2.numprg,&akk2.index,akk2.captr,&akk2.cloc1,&akk2.cloc2,&akk2.maxvlt,&akk2.sumcap);break; //  2
                	case 5: stopzrz_akk2();break; // -  2
                	case 6: setadc_zrocur();break; //       -
					case 7: podgot_setadc();break; //        
                	}
            	}
        	}
		}
	}

